abt.boot.ci <- function(abts, var=1, npts=50, location=mean, spread=function(x) 2*sd(x),
	plt=TRUE, ...) {
	nrep <- length(abts)
	for (i in 1:nrep) {
	pt <- plot(abts[[i]], i.var=var, se=F,  return.grid=T)
	if (i==1) {
		x <- pt[,1]
		res <- matrix(NA, nrow=length(x), ncol=nrep)
	}
	res[,i] <- pt[,2]
	}
	loc <- apply(res,1,location)
	sp <- apply(res,1,spread)
	mat <- cbind(loc,loc-sp,loc+sp)
	if (plt) {
	xl <- abts[[1]][[1]]$var.names[var]
	yl <- paste("f(",xl,")",sep="")
	print(x)
	print(mat)
	if (is.numeric(x)) matplot(x, mat, lty=c(1,2,2), col=c(1,2,2), type="l",xlab=xl,ylab=yl,...)
	else {
	plot(x, mat[,1], pch=16, type="p",xlab=xl,ylab=yl,...)
	segments(1:length(x),mat[,2],1:length(x),mat[,3])
	}
	}
	invisible(mat)
}
