abt.dev <-
function(fit) {
	gaussian <- function(y,f) sum((y-f)^2)
	binomial <- function(y,f) sum(2*(y*log(ifelse(y==0,1,y/f))+(1-y)*log(ifelse(y==0),1,(1-y)/(1-f))))
	poisson <- function(y,f) sum(2*(y*log(ifelse(y==0,1,y/f))-(y-f)))
	laplace <- function(y,f) sum(abs(y-f))
	invlogit <- function(y) 1/(1+exp(-y))
	dist <- fit[[1]]$distribution
	if (dist=="gaussian") {
		dev.fun <- gaussian
		fun <- I
	}
	else if (dist=="bernoulli") {
		dev.fun <- binomial
		fun <- invlogit
	}
	else if (dist=="poisson") {
		dev.fun <- poisson
		fun <- exp
	}
	else if (dist=="laplace") {
		dev.fun <- laplace
		fun <- I
	}
	yf <- fun(fit[[1]]$fitted)
	y <- fit[[1]]$mdata[,1]
	n <- length(y)
	ym <- mean(y)
	dev0 <- dev.fun(y,ym)/n
	dev1 <- dev.fun(y,yf)/n
	list(dev0=dev0,dev1=dev1,dev.proportion=(dev0-dev1)/dev0)
}

