abt.perm <-
function(abt.fit, reps=100, verbose=F) {
	trms <- attr(abt.fit[[1]]$Terms,"term.labels")
	nt <- length(trms)
	y <- abt.fit[[1]]$mdata[,1]
	n <- length(y)
	res <- matrix(0,nrow=3,ncol=nt)
	dimnames(res) <- list(c("Influence(%)","Error","P"),trms)
	res[1,] <- summary(abt.fit,ord=F,plotit=F)[,2]
	err1 <- loss(abt.fit)
	mres <- matrix(NA,nrow=reps,ncol=nt)
	if (verbose) cat("Permuting predictors: ")
	for (i in 1:nt) {
		if (verbose) cat("\n",trms[i]," ")
		for (j in 1:reps) {
			if (verbose) cat(j," ")
			temp <- abt.fit[[1]]$mdata
			temp[,trms[i]] <- temp[sample(n),trms[i]] 
			ppreds <- predict2.abt(abt.fit,olddata=temp)
			mres[j,i] <- loss(abt.fit,f=ppreds)
		}
		res[2,i] <- mean(mres[,i])
		res[3,i] <- mean(err1[[1]] > mres[,i])
	}
	cat("\nPredicted error =",signif(err1,4),"\n") 
	print(round(res,3))
	invisible(list(err=err1,table=res,mres=mres))
}

