estBisqParam <- function(x=0.85)
{
   if (is.null(x) || !is.numeric( x ))
   {
      Misc <- 3.443689
   } else 
   if ( x < 0.80 | x > 0.95 )
   {
      stop("Only bisquare efficiency between 0.8 and 0.95 is currently supported")
   } else 
   { 
      # Borrowed from lmRob.fit.compute in the robust package
      if (x==0.95){ Misc <- 4.685061 }
      else if (x==0.90){ Misc <- 3.882646 }
      else if (x==0.85){ Misc <- 3.443689 }
      else if (x==0.80){ Misc <- 3.136909 }
      else 
      {
         s <- spline(c(0.80,0.85,0.90,0.95), 
                     c(3.136909,3.443689,3.882646,4.685061), n=500)
         Misc <- s$y[ abs( s$x - x ) == min( abs( s$x - x ) ) ]
      }
   }
   return(Misc)
}

