plot.all <-
function (obj, summary = TRUE, ord = T, se.n = 2, n.vars, nn, main = NULL, 
    colbar = "grey", par.set = TRUE, las=1, ...) 
{
    if (par.set) {
	    op <- par(no.readonly = TRUE, las=las)
	    on.exit(par(op))
    }
    if (!summary) 
        ord <- FALSE
    if (any(class(obj)=="single")) 
        vnames <- obj$var.names
    else vnames <- obj[[1]]$var.names
    if (missing(n.vars)) 
        n <- length(vnames)
    else n <- n.vars
    if (par.set) {
	    if (missing(nn)) 
        nn <- nbig.plt(n + summary)
    		par(mfrow = nn, mar = c(5, 4, 0.25, 0.25) + 0.1)
    }
    if (summary) 
        print(sumry <- summary.abt(obj, main = main, colbar = colbar))
    if (ord) 
        ords <- match(sumry[, 1], vnames)[1:n]
    else ords <- 1:n
    for (i in ords) plot.abt(obj, i, se = se.n, ...)
}

