aaCoast <- function(data, land = ning.coast.smooth) {

##
## Calculates the relative distance across & along the Ningaloo Coast
## "data" is a matrix containing the longs (column 1) and lats (column 2)
## "land" is the (smoothed !!) land boundary
##

  index <- findNeighbours(data, land)
  across <- findDistances(data, land, index)
  dists <- sqrt(rowSums(as.matrix(land[-nrow(land),] - land[-1,]))^2)
  along <-   cumsum(c(0,dists))[index]
  cbind(across = across, along = along)
}

