acrossAlong <- function(data, land = landonly, reef = outonly,
        north = nrthonly, south = sthonly, out = outonly, check = TRUE) {
##
## Calculates the relative distance across & along the GBR
## "data" is a matrix containing the longs (column 1) and lats (column 2)
## "land", "reef", "north", "south" are the 4 boundaries
## "out" checks for point beyond the outer bounday and recalulates these distances
##

  x1 <- findDistances(data, land)
  x2 <- findDistances(data, reef)
  y1 <- findDistances(data, south)
  y2 <- findDistances(data, north)
  across <- x1/(x1+x2)
  along <- y1/(y1+y2)
  if(check) {
        outside <- aapoly.in(data, out)
 		if (any(outside)) across[outside] <- 1/across[outside]
  }
  cbind(across = across, along = along)
}

