findNeighbours <- function (members, neighbours, index =
1:nrow(neighbours)) {
  if(!require(class, quietly = TRUE))
    stop("The 'class' package from the VR bundle needs to be
installed.")
  neighbours <- as.matrix(neighbours)
  if(!is.numeric(neighbours)) stop("non-numeric neighbours")
  members <- as.matrix(members)
  if(!is.numeric(members)) stop("non-numeric members")
  if (any(is.na(neighbours)) || any(is.na(members)) ||
any(is.na(index)))
    stop("missing values are not allowed")

  members <- as.matrix(members)
  p <- ncol(neighbours)
  numberOfNeighbours <- nrow(neighbours)
  if (length(index) != numberOfNeighbours)
    stop("neighbours and class have different lengths")
  numberOfMembers <- nrow(members)
  if (ncol(members) != p)
    stop("column dimensions of members and neighbours differ")
  indexf <- as.factor(index)
  nc <- length(levels(indexf))
  index[.C("VR_knn1",
           as.integer(numberOfNeighbours),
           as.integer(numberOfMembers),
           as.integer(p),
           as.double(neighbours),
           as.integer(unclass(indexf)),
           as.double(members),
           res = integer(numberOfMembers),
           integer(nc + 1),
           as.integer(nc),
           d = double(numberOfMembers),
           PACKAGE = "class")$res]
}

