"ganova" <-
function (object, ...)
{
    if (length(list(object, ...)) > 1)
        return(ganova.list(object, ...))
    w <- object$weights
    n <- length(object$resid)
    ssr <- sum(if (is.null(w))
        object$resid^2
    else w * object$resid^2)
    dfr <- df.residual(object)
    p <- object$rank
    if (p > 0) {
        p1 <- 1:p
        comp <- object$effects[p1]
        asgn <- object$assign[object$qr$pivot][p1]
        nmeffects <- c("(Intercept)", attr(object$terms, "term.labels"))
        tlabels <- nmeffects[1 + unique(asgn)]
        ss <- c(unlist(lapply(split(comp^2, asgn), sum)), ssr)
        df <- c(unlist(lapply(split(asgn, asgn), length)), dfr)
    }
    else {
        ss <- ssr
        df <- dfr
        tlabels <- character(0)
    }
    ms <- ss/df
    f <- ms/(ssr/dfr)
    P <- pf(f, df, dfr, lower.tail = FALSE)
    table <- data.frame(df, ss, ms, f, P)
    np <- length(P)
    table[np, 4:5] <- NA
    dimnames(table) <- list(c(tlabels, "Residuals"), c("Df",
        "Sum Sq", "Mean Sq", "F value", "Pr(>F)"))
    sst <- rev(c(NA,cumsum(ss[np:2])))/ms[np]
    pp <- rev(c(NA,n-cumsum(df[np:2])))
    table$"AIC" <- sst + 2 * pp
    table$"AICC" <- sst + 2 * pp * (1 + (pp + 1)/(n - pp - 1))
    table$"BIC" <- sst + log(n) * pp
       if (attr(object$terms, "intercept"))
        table <- table[-1, ]
    structure(table, heading = c("Analysis of Variance Table",
        paste("Response:", deparse(formula(object)[[2]]))), class = c("anova",
        "data.frame"))
}

