`hs` <-
function (gui = "irrelevant", browser = getOption("browser"), 
    remote = NULL) 
{
    if (is.null(browser)) 
        stop("invalid browser name, check options(\"browser\").")
    if (browser != getOption("browser")) {
        msg <- gettext("Changing the default browser (as specified by the 'browser' option) to the given browser so that it gets used for all future help requests.")
        writeLines(strwrap(msg, exdent = 4))
        options(browser = browser)
    }
    cat(gettext("Making links in per-session dir ...\n"))
    .Script("sh", "help-links.sh", paste(tempdir(), paste(.libPaths(), 
        collapse = " ")))
    make.packages.html()
    tmpdir <- paste("file://", URLencode(tempdir()), "/.R", sep = "")
    url <- paste(if (is.null(remote)) 
        tmpdir
    else remote, "/doc/html/index.html", sep = "")
    writeLines(strwrap(gettextf("If '%s' is already running, it is *not* restarted, and you must switch to its window.", 
        browser), exdent = 4))
    writeLines(gettext("Otherwise, be patient ..."))
    browseURL(url)
    options(htmlhelp = TRUE)
}
