lf <- function(...) list.files(...)

si <- function(...) save.image(...)

hs <- function(...) help.start(...)

hf <- function(...) help.search(...)

asch <- function(...) as.character(...)

sh <- function(...) savehistory(...)

cep <- function(name="fig1", ...) {
    feps <- paste(name, "eps", sep = ".")
    fpdf <- paste(name, "pdf", sep = ".")
    dev.copy2eps(file = feps, ...)
    dev.copy2pdf(file = fpdf, ...)
}

copyFig <- function(name = "fig1", size = 3, eps = TRUE, pdf = FALSE, png = TRUE, ...) 
{
    feps <- paste(name, "eps", sep = ".")
    fpng <- paste(name, "png", sep = ".")
    fpdf <- paste(name, "pdf", sep = ".")
    if (eps|png) dev.copy2eps(file = feps, ...)
    if (pdf) dev.copy2eps(file = fpdf, ...)
	if (png) {
		size <- paste(round(size * 12 * par()$din[1]), round(size * 12 * par()$din[2]), sep="x")
		system(paste("convert -density", size, feps, fpng, sep = " "))
		if (!eps) 
		    system(paste("rm", feps, sep = " "))
    }
}

cpng.big <- function(name = "fig1", size = 3, rm.eps = FALSE, ...) 
{
    feps <- paste(name, "eps", sep = ".")
    fpng <- paste(name, "png", sep = ".")
    dev.copy2eps(file = feps, ...)
	size <- paste(round(size * 12 * par()$din[1]), round(size * 12 * par()$din[2]), sep="x")
	system(paste("convert -density", size, feps, fpng, sep = " "))
    if (rm.eps) 
        system(paste("rm", feps, sep = " "))
}

cpng <- function(file = "fig", type = "Xlib", size=72, ...) 
{
    dev.copy(png, file = paste(file,".png",sep=""), type = type, width = round(size * 
        par()$din[1]), height = round(size * par()$din[2]), ...)
    dev.off()
}

cpdf <- function(file = "fig", ...) 
{
    dev.copy(pdf, file = paste(file,".pdf",sep=""), width = par()$din[1], 
	height = par()$din[2], ...)
    dev.off()
}

x11g <- X11g <- 
function (wid = 6, hei = 6, pts = 12, xpos = 1175, ypos = 0, las = 1,...) {
    X11(width = wid, height = hei, point = pts, xpos = xpos, ypos = ypos,
        bg = "white", ...)
    par(las = las)
}


go <- function() graphics.off()

cut2 <- function(x,n) cut(x,breaks=seq(min(x),max(x),length=n),include=T)

ipkgs <- function(pkgs) install.packages(pkgs,lib="/usr/lib/R/library", repos="http://cran.ms.unimelb.edu.au")

upkgs <- function() update.packages(lib.loc="/usr/lib/R/library", repos="http://cran.ms.unimelb.edu.au")



