lm.gd <- 
function (form, data, se = 2,  add.pts = TRUE,  xlab, ylab, 
    pch = 1, cex = 1, main = NULL, xlim, ylim, summary = F, ...) 
{
    fit <- lm(form, data, ...)
	if (summary) print(summary(fit))
    pred <- predict(fit, se = T)
    if (missing(xlab)) 
        xlab <- fit$xnames[[1]]
    if (missing(ylab)) 
        ylab <- form[[2]]
    if (missing(xlim)) 
        xlim <- range(fit$x)
    if (missing(ylim)) 
        ylim <- range(c(fit$y, pred$fit + se * pred$se.fit, 
            pred$fit - se * pred$se.fit))
    plot(fit, xlab = xlab, ylab = ylab, xlim = xlim, ylim = ylim, 
        pch = pch, cex = cex, main = main)
    ord <- order(fit$x)
    lines(fit$x[ord], fit$fit[ord], col = "red", lwd = 2)
    lines(fit$x[ord], pred$fit[ord] + se * pred$se.fit[ord], 
        col = "darkblue", lwd = 1)
    lines(fit$x[ord], pred$fit[ord] - se * pred$se.fit[ord], 
        col = "darkblue", lwd = 1)
	invisible(fit)
}

