"loess.gd" <-
function (form, data, se = 2, ptype = c("image", "persp"), np = 50,
    add.pts = TRUE, add.cont = TRUE, ncolors = np, xlab, ylab, pch=1,
    cex=1, main=NULL, xlim, ylim, ...)
{
    fit <- loess(form, data, ...)
    if (length(fit$xnames) == 1) {
        pred <- predict(fit, se = T)
        if (missing(xlab)) xlab<-fit$xnames[[1]]
        if (missing(ylab)) ylab<-form[[2]]
        if (missing(xlim)) xlim<-range(fit$x)
        if (missing(ylim)) ylim<-range(c(fit$y,pred$fit+se*pred$se.fit,pred$fit-se*pred$se.fit))
        plot(fit, xlab = xlab, ylab = ylab, xlim=xlim, ylim=ylim, pch=pch, cex=cex,main=main)
        ord <- order(fit$x)
        lines(fit$x[ord], fit$fit[ord], col = "red", lwd = 2)
        lines(fit$x[ord], pred$fit[ord] + se * pred$se.fit[ord],
            col = "darkblue", lwd = 1)
        lines(fit$x[ord], pred$fit[ord] - se * pred$se.fit[ord],
            col = "darkblue", lwd = 1)
    }
    else if (length(fit$xnames) == 2) {
        pred <- predict(fit, se = T)
        int <- interp(fit$x[, 1], fit$x[, 2], pred$fit, xo = seq(min(fit$x[,
            1]), max(fit$x[, 1]), length = np), yo = seq(min(fit$x[,
            2]), max(fit$x[, 2]), length = np), duplicate = "mean")
        if (ptype[1] == "image") {
            image(int, col = heat.colors(n = ncolors),...)
            if (add.cont)
                contour(int, add = T,...)
            if (add.pts)
                points(fit$x[, 1], fit$x[, 2],...)
        }
        else persp(int, ...)
    }
    else cat("Only handles 1D and 2D plots\n")
	invisible(fit)
}

