"m2u" <-
function(data, responses, carrys, drop0 = F, collab = "time",
                 idlab = "id", ylab = "response")
{
#
# converts multivariate RM data to univariate Rm format
# data is the data frame in MV format
# responses defines response columns and carrys the cols to be expanded
#
#
    nr <- nrow(data)
    gnames <- names(data)[responses]
    ny <- length(responses)
    if(!missing(carrys)) {
        xx <- data[rep(1:nr, rep(ny, nr)), carrys, drop = F]
        xx <- cbind(xx, ordered(rep(gnames, nr)), factor(rep(1:nr, rep(ny, nr))), as.vector(t(data[, responses])))
    }
    else xx <- data.frame(cbind(ordered(rep(gnames, nr)), factor(rep(1:nr, rep(ny, nr))), as.vector(t(data[, responses]))
            ))
    names(xx)[(ncol(xx) - 2):ncol(xx)] <- c(collab, idlab, ylab)
    row.names(xx) <- c(1:(ny * nr))
    if(drop0)
        xx <- xx[xx[, ylab] != 0,  ]
    xx
}

