nearGeo <- function (xx, yy) {
    require(sp)
    x <- as.matrix(xx[, c("long","lat"),drop=F])
    y <- as.matrix(yy[, c("long","lat"),drop=F])
    nx <- nrow(x)
    ny <- nrow(y)
    pos <- rep(NA, nx)
    min.dist <- rep(NA, nx)
    for (i in 1:nx) {
		dist <- spDistsN1(y, x[i,,drop=F], longlat=TRUE)
        min.dist[i] <- min(dist, na.rm = T)
        pos[i] <- ((1:ny)[dist == min.dist[i]])[1]
    }
    cat("Summary of min distances :\n")
    print(summary(min.dist))
    data.frame(xx, yy[pos, ,drop=F], min.dist)
}



