"nearest" <-
function(xx, yy, mindsq = 0.1)
{
    x <- xx[, c("lat", "long")]
    y <- yy[, c("lat", "long")]
    mindsq <- mindsq^2
    nx <- nrow(x)
    ny <- nrow(y)
    pos <- rep(NA, nx)
    min.dist <- rep(NA, nx)
    for(i in 1:nx) {
        distsq <- signif((x[i, 1] - y[, 1])^2 + (x[i, 2] - y[, 2])^2, 5)
        min.dist[i] <- min(distsq, na.rm = T)
        if(min.dist[i] < mindsq)
            pos[i] <- ((1:ny)[distsq == min.dist[i]])[1]
    }
    mindist <- sqrt(min.dist)
    cat("Summary of min distances :\n")
    print(summary(min.dist))
    data.frame(xx, yy[pos,  ], min.dist)
}

