"pcsim.xx" <-
function (p = 10, n = 100, nx = 5, FUN = apply(x, 1, sum), strip0 = T, 
    extreme = 0, complex = F, ret = T, d.rand = T, mu.rand = T, 
    s = (4:8)/10, amp = c(15, 20, 10, 5, 25), lst = F, err = 1, 
    err.type = "p", f = 0.25, eps = 1e-05, beta.div = 1, plotit = T, 
    ptype = "l", invert = 0, sd = 3, trim = F, add.rug = F, lin = F, 
    as.df = T, ...) 
{
    if (!missing(s) && length(s) == 1) 
        s <- rep(s, 5)
    s <- s * beta.div
    if (!missing(amp) && length(amp) == 1) 
        amp <- rep(amp, 5)
    x <- matrix(NA, nrow = n, ncol = p + nx)
    xs <- matrix(NA, nrow = n, ncol = p + nx)
    rowins <- rep(T, p + 1)
    colins <- rep(T, p + 1)
    if (d.rand) 
        dd <- matrix(runif(nx * n, 0, 1), nrow = n)
    else dd <- matrix((0:(nx - 1))/(nx - 1), nrow = n)
    d <- FUN(dd)
    if (mu.rand) {
        if (!extreme) 
            mu <- runif(p, 0, 1)
        else mu <- runif(p, -0.1, 1.1)
    }
    else if (!extreme) 
        mu <- (0:(p - 1))/(p - 1)
    else mu <- (0:(p - 1))/(p - 1) * extreme - extreme/2 + 0.5
    k <- sample(1:5, p, replace = T)
    l <- sample(1:5, p, replace = T)
    if (complex) {
        invert <- 0.5
        ni <- round(invert * p)
        inv <- c(rep(1, ni), rep(0, p - ni))[sample(p)]
    }
    else inv <- rep(0, p)
    for (i in 1:p) {
        if (!err) {
            x[, i + nx] <- amp[l[i]] * exp(-0.5 * ((d - mu[i])/s[k[i]])^2)
            if (trim) 
                x[abs((d - mu[i])/s[k[i]]) > sd, i + nx] <- 0
            if (inv[i] == 1) 
                x[, i + nx] <- max(x[, i + nx]) - x[, i + nx]
        }
        else {
            xs[, i + nx] <- amp[l[i]] * exp(-0.5 * ((d - mu[i])/s[k[i]])^2 + 
                eps)
            if (inv[i] == 1) 
                xs[, i + nx] <- max(xs[, i + nx]) - xs[, i + 
                  nx] + eps
            if (err.type == "p") 
                x[, i + nx] <- rpois(n, xs[, i + nx])
            else if (err.type == "n") 
                x[, i + nx] <- xs[, i + nx] + err * rnorm(n, 
                  0, 1)
        }
        NULL
    }
    if (lin) {
        for (i in 1:p) {
            x[, i + nx] <- 10 + rnorm(1, 0, 3) * d
            if (err) 
                x[, i + nx] <- x[, i + nx] + err * rnorm(n, 0, 
                  1)
            NULL
        }
    }
    if (complex) {
        yfit <- diag(ifelse(apply(x[, -c(1:nx)], 1, sum) == 0, 
            1, 50/apply(x[, -c(1:nx)], 1, sum)))
        x[, -c(1:nx)] <- yfit %*% x[, -c(1:nx)]
    }
    x[, 1:nx] <- d
    if (strip0) {
        rowins <- apply(x[, -c(1:nx)], 1, sum) != 0
        x <- x[rowins, ]
        xs <- xs[rowins, ]
        colins <- c(T, (apply(x[, c(1:nx)], 2, sum) != 0))
        x <- x[, colins]
        xs <- xs[, colins]
    }
    x <- cbind(d, x)
    xs <- cbind(d, xs)
    ord <- order(x[, 1])
    x <- x[ord, ]
    xs <- xs[ord, ]
    dimnames(x) <- list(as.character(1:length(x[, 1])), c("Gradient", 
        paste("Env", 1:nx, sep = "."), paste("Taxa", 1:p, sep = ".")))
    dimnames(xs) <- dimnames(x)
    if (plotit) {
        z <- rev(order(x[, 1]))
        matplot(x[z, 1], as.matrix(x[z, -c(1:(nx + 1))]), type = ptype, 
            lty = 1, col = 1:5, xlab = "Locations", ylab = "Response", 
            main = "Simulated Data")
        if (add.rug) 
            rug(x[z, 1], side = 3)
    }
    if (ret) {
        if (lst) 
            list(x = x, xs = xs, sigma = s[k[1:p]][colins[-1]], 
                amp = amp[l[1:p]][colins[-1]], mu = mu[1:p][colins[-1]])
        else if (as.df) 
            data.frame(x)
        else x
    }
}
