"pintol.fit2" <-
function(x=x, y=y, a=a, b=b, subset = subset, df = df, test=test.type,
        fit.linear=fit.linear, fit.smooth=fit.smooth, diag.fit = diag.fit) {
    if (fit.linear | fit.smooth) {
        y <- y[subset]
        x <- x[subset]
        if (!is.null(a))
            a <- a[subset]
        if (!is.null(b))
            b <- b[subset]
    }
    if (fit.linear & !fit.smooth) {
        print(anova(lmfit <- lm(y ~ x),test=test))
        if (is.null(b)) {
            if (!is.null(a))
                print(anova(lmfit <- lm(terms(y ~ x + a + x:a,
                  keep.order = T)),test=test))
        }
        else {
            print(anova(lmfit <- lm(terms(y ~ x + b + x:b,
                keep.order = T)),test=test))
            if (!is.null(a))
                print(anova(lmfit <- lm(terms(y ~ x + b +
                  x:b + a + a:x + a:b:x, keep.order = T)),test=test))
        }
        fitted <- T
    }
    if (fit.smooth & !fit.linear) {
        if (is.factor(x)) {
            cat("\n\n Spline fit specified when x is a factor : fit declined !!\n\n")
        }
        else {
            if (df < 3)
                cat("\n\n Warning : specified df < 3, df = 3 used in ANOVAS\n\n")
            print(anova(lmfit <- lm(y ~ splines::ns(x, df = df)),test=test))
            if (is.null(b)) {
                if (!is.null(a))
                  print(anova(lmfit <- lm(terms(y ~ splines::ns(x, df = df) +
                    a + splines::ns(x, df = df):a, keep.order = T)),test=test))
            }
            else {
                print(anova(lmfit <- lm(terms(y ~ splines::ns(x, df = df) +
                  b + splines::ns(x, df = df):b, keep.order = T)),test=test))
                if (!is.null(a))
                  print(anova(lmfit <- lm(terms(y ~ splines::ns(x, df = df) +
                    b + splines::ns(x, df = df):b + a + a:splines::ns(x,
                    df = df) + a:b + a:b:splines::ns(x, df = df),
                    keep.order = T)),test=test))
            }
            fitted <- T
        }
    }
    if (fit.smooth & fit.linear) {
        if (is.factor(x)) {
            cat("\n\n Spline fit specified when x is a factor : fit declined !!\n\n")
        }
        else {
            if (df < 3)
                cat("\n\n Warning : specified df < 3, df = 3 used in ANOVAS\n\n")
            print(anova(lmfit <- lm(y ~ x + splines::ns(x, df = df)),test=test))
            if (is.null(b)) {
                if (!is.null(a))
                  print(anova(lmfit <- lm(terms(y ~ x + splines::ns(x,
                    df = df) + a + x:a + splines::ns(x, df = df):a, keep.order = T)),test=test))
            }
            else {
                print(lmfit <- anova(lmfit <- lm(terms(y ~ x +
                  splines::ns(x, df = df) + b + x:b + splines::ns(x, df = df):b,
                  keep.order = T)),test=test))
                if (!is.null(a))
                  print(anova(lmfit <- lm(terms(y ~ x + splines::ns(x,
                    df = df) + b + x:b + splines::ns(x, df = df):b +
                    a + a:x + a:splines::ns(x, df = df) + a:b:x + a:b:splines::ns(x,
                    df = df), keep.order = T)),test=test))
            }
            fitted <- T
        }
    }
    if (diag.fit & fitted) {
        par(mfrow = c(2, 2))
        locator(1)
        pint.plt(lmfit)
    }
}

