"pintol.glm" <-
function (x, y, family = "gaussian", df = 4, nse = 2, use.mean.dev = T,
    nint = 50, lwd = 1, lty = 1, col = 1, ...)
{
    x <- as.numeric(x)
    y <- as.numeric(y)
    if (length(x) > 0) {
        fit <- glm(y ~ ns(x, df), family = family)
		dat <- data.frame(x=seq(min(x),max(x),length=nint))
		if (!nse) yp <- predict(fit,newdata=dat,se=F,type = "link")
		else {
			fitted <- predict(fit,newdata=dat,se=T,type = "link")
			yp <- fitted$fit
			se.yp <- fitted$se.fit			
		}
        if (use.mean.dev & family != "gaussian")
            se.yp <- se.yp * sqrt(fit$dev/fit$df.res)
        if (family == "poisson")
            yp <- exp(yp)
        else if (family == "binomial")
            yp <- 1/(1 + exp(-yp))
        else yp <- yp
        lines(x = dat$x, y = yp, col = col, lty = lty, lwd = lwd)
        if (nse) {
            if (family == "poisson") {
                yp.hi <- exp(yp + nse * se.yp)
                yp.lo <- exp(yp - nse * se.yp)
            }
            else if (family == "binomial") {
                yp.hi <- 1/(1 + exp(-yp - nse * se.yp))
                yp.lo <- 1/(1 + exp(-yp + nse * se.yp))
            }
            else {
                yp.hi <- yp + nse * se.yp
                yp.lo <- yp - nse * se.yp
            }
            lines(x = dat$x, y = yp.hi, col = col, lty = lty, lwd = lwd)
            lines(x = dat$x, y = yp.lo, col = col, lty = lty, lwd = lwd)
        }
    }
}

