"pintol.loess" <-
function (x, y, span = 0.75, degree = 1, nse = 2, nint = 50,
    family = c("symmetric", "gaussian")[1], evaluation = 50, lwd = 1, lty = 1,
    col = 1, ...)
    {
    x <- as.numeric(x)
    y <- as.numeric(y)
    fit <- loess(y~x, span = span, family = "symmetric",
		degree = degree, evaluation = evaluation)
	dat <- data.frame(x=seq(min(x),max(x),length=nint))
	if (!nse) yp <- predict(fit,newdata=dat,se=F,type = "link")
	else {
		fitted <- predict(fit,newdata=dat,se=T,type = "link")
		yp <- fitted$fit
		se.yp <- fitted$se.fit			
	}
    lines(x = dat$x, y = yp, col = col, lty = lty, lwd = lwd)
    if (nse) {
        if (family == "poisson") {
            yp.hi <- exp(yp + nse * se.yp)
            yp.lo <- exp(yp - nse * se.yp)
        }
        else if (family == "binomial") {
            yp.hi <- 1/(1 + exp(-yp - nse * se.yp))
            yp.lo <- 1/(1 + exp(-yp + nse * se.yp))
        }
        else {
            yp.hi <- yp + nse * se.yp
            yp.lo <- yp - nse * se.yp
        }
        lines(x = dat$x, y = yp.hi, col = col, lty = lty, lwd = lwd)
        lines(x = dat$x, y = yp.lo, col = col, lty = lty, lwd = lwd)
    }
}

