"spline.gd" <-
function(x, y, df = 7, cv = T, conf = 2, penalty = 1, pts = T, pch = 1, ret = T, cexpch = 1, r2 = F,
     ylim, xlim, ...)
{
    xyna <- is.na(x) | is.na(y)
    if(any(xyna)) {
        x <- x[!xyna]
        y <- y[!xyna]
        cat(sum(xyna), " cases missing\n")
    }
    if(!missing(df))
        fit <- smooth.spline.gd(x, y, df = df)
    else if(!missing(penalty))
        fit <- smooth.spline.gd(x, y, cv = F, penalty = penalty)
    else fit <- smooth.spline.gd(x, y, cv = T)
    len <- length(fit$x)
    ins <- rep(1:len, fit$w)
    fit$x <- fit$x[ins]
    fit$y <- fit$y[ins]
    y <- y[order(x)]
    x <- x[order(x)]
    fit$yin <- fit$yin[ins]
    fit$lev <- (fit$lev/fit$w)[ins]
    res <- (y - fit$y)
    sres <- res/(1 - fit$lev)
    totss <- sum((y - mean(y))^2)
    sigma <- sqrt(var(sres))
    err <- conf * sigma * sqrt(fit$lev)
    if(missing(ylim))
        ylim <- range(c(fit$y + err, fit$y - err, y))
    if(missing(xlim))
        xlim <- range(fit$x)
    plot(fit$x, fit$y, ylim = ylim, xlim = xlim, type = "n")
    if(pts)
        points(x, y, pch = pch, cex = cexpch)
    lines(fit$x, fit$y, col = 2, lwd = 1)
    if(r2)
        mtext(paste("R2 = ", round(100 * (1 - sum(res^2)/totss), 1), "%"), side = 3, line = 1)
    if(conf) {
        lines(fit$x, fit$y + err, lty = 1, col = 4, lwd = 1)
        lines(fit$x, fit$y - err, lty = 1, col = 4, lwd = 1)
    }
    fit$yin <- y
    list(fit = fit, y = fit$y, se = err/conf)
}

