"splitRfiles" <- function (from = "d:/rwork/rw221src", to = from, lib, warn = FALSE) 
{
    if (warn & length(ls(pos=parent.frame()))) {
        cat("There are objects in this workspace -- Remove them (y/n) >  ")
        z <- readLines(n=1)
        if (z=="y" || z=="Y") rm(list=ls(pos=parent.frame()),envir=parent.frame())
        else return()
    }
    else rm(list=ls(pos=parent.frame()),envir=parent.frame())

    if (missing(lib)) {
        from <- choose.files(from, multi=F)
        to <- paste(dirname(from),"/",sep="")
    }
    else {
        from <- paste(from,lib,"R",paste(lib,".R",sep=""),sep="/")
        to <- paste(to,lib,"R/",sep="/")
    }

    cat("Sourcing files from ", from, "\n")
    source(from)
    print(files <- ls(pos = parent.frame()))
    nf <- length(files)  
    cat("Dumping files to ", to, "\n")
    for (i in 1:nf) {
        dump(ls(pos = parent.frame())[i], file = paste(to, files[i], ".R",sep = ""))
    }
    file.remove(from)
    rm(list=ls(pos=parent.frame()),envir=parent.frame())
}
