"stat.ganova" <-
function (table, test = c("Chisq", "F", "Cp", "IC*", "IC"), scale, df.scale, n)
{
    test <- match.arg(test)
    dev.col <- match("Diff Dev", colnames(table))
    for (i in length(test))
    switch(test, Chisq = {
        cbind(table, "P(>|Chi|)" = pchisq(abs(table[, dev.col]/scale),
            abs(table[, "Diff Df"]), lower.tail = FALSE))
    }, F = {
        Fvalue <- abs((table[, dev.col]/table[, "Diff Df"])/scale)
        Fvalue[table[, "Diff Df"] == 0] <- NA
        cbind(table, F = Fvalue, "Pr(>F)" = pf(Fvalue, abs(table[,
            "Diff Df"]), abs(df.scale), lower.tail = FALSE))
    }, Cp = {
        cbind(table[,1:2], "Mean Dev." = table[,2]/table[,1],
        Cp = table[, "Deviance"] + 2 * scale * (n - table[, "Dev Df"]))
    }, "IC*" = {
        cat("IC* -- Using unscaled IC\n")
        resid.dev <- table[,"Deviance"]
        p <- (n - table[,"Dev Df"])
        table <- table[,1:2]
        table$"Mean Dev." <- table[,2]/table[,1]
        table$"AIC*" <- resid.dev + 2 * p
        table$"AICC*" <- resid.dev + 2 * p * (1 + (p + 1)/(n - p - 1))
        table$"BIC*" <- resid.dev + log(n) * p
        table
    }, "IC" = {
        cat("IC -- Using scaled IC\n")
        resid.dev <- table[,"Deviance"]
        p <- (n - table[,"Dev Df"])
        table <- table[,1:2]
        table$"Mean Dev." <- table[,2]/table[,1]
        table$"AIC" <- resid.dev/scale + 2 * p
        table$"AICC" <- resid.dev/scale + 2 * p * (1 + (p + 1)/(n - p - 1))
        table$"BIC" <- resid.dev/scale + log(n) * p
        table
    })
}

