treeform <-
function (data, ycol, xcol, FUN, maxy = 20, gam = F, cbind = F, extra) 
{
    ny <- length(ycol)
    nx <- ifelse(xcol[1] != 0, length(xcol), 0)
    dnames <- colnames(data)
    if (gam) {
        for (i in 1:nx) if (is.numeric(data[,xcol[i]])) 
       		dnames[xcol[i]] <- paste("s(",dnames[xcol[i]],")")
    }
    if (ny > maxy) {
        yy <- deparse(substitute(ycol))
        ty <- paste("as.matrix(", deparse(substitute(data)), 
            "[,", yy, "])", collapse = "", sep = "")
        if (!missing(FUN)) 
            ty <- paste(deparse(substitute(FUN)), "(", ty, ")", 
                sep = "")
        if (nx > 1) 
            tx <- paste(dnames[xcol], collapse = "+")
        else if (nx == 1) 
            tx <- dnames[xcol]
        else tx <- "1"
        form <- paste(ty, tx, collapse = "", sep = "~")
    }
    else {
        if (ny > 1) {
            if (cbind) {
                ty <- paste(dnames[ycol], collapse = ",")
                ty <- paste("cbind(", ty, ")", collapse = "", 
                  sep = "")
            }
            else ty <- paste(dnames[ycol], collapse = "+")
        }
        else if (ny == 1) 
            ty <- dnames[ycol]
        else ty <- ""
        if (!missing(FUN)) 
            ty <- paste(deparse(substitute(FUN)), "(", ty, ")", 
                sep = "")
        if (nx > 1) 
            tx <- paste(dnames[xcol], collapse = "+")
        else if (nx == 1) 
            tx <- dnames[xcol]
        else tx <- "1"
        if (missing(extra)) 
            form <- paste(ty, "~", tx, collapse = "", sep = "")
        else form <- paste(ty, "~", extra, tx, collapse = "", 
            sep = "")
    }
    formula(form)
}
