"u2m" <-
function (data, new.rows, new.cols, response, carrys, missings = 0,
    check.grps = T, check.carrys = T)
{

#
# new.rows are the col numbers that define the new rows (OUs)
# new.cols is the col number that defines the new cols ("times")
# response is the col number of the response
# carrys are the col numbers to be carried (ie converted to non-time varying covariates)
# missings is the value filled into non entries in the new response matrix
# check.grps checks if duplicates entries exist in the new response matrix
# check.carrys checkd for time varying carried variables
#
#  Fixed order bug -- GD -- 18-8-04
#
    number <- function(x) {
        match(x, sort(unique(x)))
    }
    if (length(new.rows) > 1)
        pmat <- do.call("paste", as.data.frame(data[,
            new.rows]))
    else pmat <- data[, new.rows]
    if (!missing(carrys))
        uxx <- data[!duplicated(pmat), unique(c(new.rows, carrys)),
            drop = F]
    else uxx <- data[!duplicated(pmat), new.rows, drop = F]
    uni.pmat <- unique(pmat)
    uxx <- uxx[order(uni.pmat),]
    nr <- nrow(uxx)
    if (check.carrys & !missing(carrys))
        if ((zln <- length(z <- unique(do.call("paste", data.frame(pmat,
            data[, carrys]))))) != nr)
            cat(" Warning -- carry column values vary over 'time'\n")
    gnames <- sort(unique(as.character(data[, new.cols])))
    grp <- number(data[, new.cols])
    y <- data[, response, drop=F]
    nc <- max(grp)
    xx <- matrix(missings, nrow = nr, ncol = nc)
    lsty <- split(y, pmat)
    lstg <- split(grp, pmat)
    if (check.grps)
        if (any(table(pmat, grp) > 1))
            cat(" Warning -- duplicates of y values in groups\n")
    for (i in 1:nr) xx[i, match(lstg[[i]], 1:nc)] <- lsty[[i]]
    colnames(xx) <- gnames
    xx <- data.frame(uxx, xx)
    xx
}

