wideMat <-
function (data, rows, cols, values, mval = 0, add.rows = T) 
{
	splitter <- function(x,xlabs) {
		lst <- do.call("rbind",lapply(strsplit(as.character(x),"\\."),unlist))
		if (!missing(xlabs)) names(lst) <- xlabs
		data.frame(x,lst)
	}
    if (add.rows) 
        name.row <- colnames(data)[rows]
    rrows <- rows
    if (length(rows)>1) rows <- interaction(data[, rrows])
    else rows <- data[, rrows]
    cols <- data[, cols]
    values <- data[, values]
    if (any(d <- duplicated(paste(rows, cols)))) 
        warning(paste("Entry", which(d), "is a duplicate\n"))
    rows <- rows[!d]
    cols <- cols[!d]
    values <- values[!d]
    rl <- sort(unique(rows))
    cl <- sort(unique(cols))
    M <- array(mval, dim = c(length(rl), length(cl)), dimnames = list(rl, cl))
    M[cbind(match(rows, rl), match(cols, cl))] <- values
    if (add.rows) {
        x <- splitter(rl,xlabs=name.row)
        M <- data.frame(x, M)
    }
    M
}

