library(MASS)
res <- rep(NA,200) 
for (i in 1:200) {
 z <- data.frame(matrix(rnorm(1050),ncol=21))
 zz <- drop1(lm(X1~.,data=z),test="F")
 res[i] <- mean(zz$"Pr(F)"[-1]<0.05)
}
mean(res)
boxplot(res)


nc <- 21; nr <- 500; nrep <- 10
res <- matrix(NA, nrow=nrep, ncol=2)
colnames(res) <- c("AIC","BIC")

cat("Rep: ")
for (i in 1:nrep) {
	cat(i,"")
	df <- data.frame(matrix(rnorm(nc*nr),ncol=nc))
	fit <- lm(X1~.,data=df)
	summary(fit)
	res[i,1]<-length(stepAIC(fit,trace=0)$coeff)-1
	res[i,2]<-length(stepAIC(fit,k=log(nr),trace=0)$coeff)-1
}
cat("\n")
res
summary(res)
boxplot(res)

nc <- 51; nr <- 1500; nrep <- 10; np <- 5; coef <- runif(nc)[1:np]
res <- matrix(NA, nrow=nrep, ncol=2)
# fam <- poisson
colnames(res) <- c("AIC","BIC")

cat("Rep: ")
for (i in 1:nrep) {
	cat(i,"")
	df <- data.frame(matrix(rnorm(nc*nr),ncol=nc))
	df$X1 <- apply(coef*t(df[,1:np]),2,sum)
	fit <- lm(X1~.,data=df)
	summary(fit)
	res[i,1]<-length(stepAIC(fit,trace=0)$coeff)-1
	res[i,2]<-length(stepAIC(fit,k=log(nr),trace=0)$coeff)-1
}
cat("\n")

res
summary(res)
boxplot(res)




