`geoPoly` <- function(fname = "Poly", reefs.add = TRUE, reefs.col = NA, reefs.line.col = "black",
	layer = zoning, layer.col, layer.add = FALSE, layer.do = rep(TRUE, length(layer)),
	layer.border = NA, google.run = TRUE, size=12, mar.no.rot = rep(0, 4), gdriver = "Xlib", ...) 
{
	if (layer.add | reefs.add)  require(layers)

	data <- data.frame(cbind(Longitude=c(142.3,153),Latitude=c(-25.1,-10.7)),Y=c(1,2))
    opt_exask <- options(example.ask = FALSE)
    qk <- SpatialPointsDataFrame(data[,1:2],data[,3,drop=F])
    summary(Sobj_SpatialGrid(qk)$SG)
    proj4string(qk) <- CRS("+proj=longlat")
    SGqk <- GE_SpatialGrid(qk)

	fname.png <- paste(fname,".png", sep = "")
	if (.Platform$GUI == "X11") png(file = fname.png, width=size * SGqk$width,
			 height=size*SGqk$height, bg="transparent",type=gdriver)
	else png(file = fname.png, width=size * SGqk$width,
			 height=size*SGqk$height, bg="transparent")
	par(mar = c(0, 0, 0, 0), xaxs = "i", yaxs = "i")
		
	geoPlot4k(qk, preds = fit$preds, xlim = SGqk$xlim, ylim = SGqk$ylim, image.add = FALSE) 
    if (reefs.add) 
        plot.polylist(reefs, xlim = SGqk$xlim, ylim = SGqk$ylim, xlab = "", 
        ylab = "",  col = reefs.col, border = reefs.line.col, add = TRUE)
    if (layer.add) {
        if (missing(layer.col) & !is.null(attr(layer, "color"))) 
            layer.col <- attr(layer, "color")
        if (class(layer) == "polylist") {
            plot.polylist(layer, col = layer.col, border = layer.border, 
            add = TRUE, forcefill = FALSE, do = layer.do, xlim = xlim, 
            ylim = ylim)
        }
        else {
            for (i in 1:length(layer)) plot.polylist(layer[[i]], 
                col = layer.col[i], add = TRUE, forcefill = FALSE,
                border = layer.border, do = layer.do, xlim = xlim, ylim = ylim)
        }
    }    
	dev.off()
	kmlOverlay2(SGqk,paste(fname,".kml",sep = ""),fname.png, adj=0, order=7)
	invisible()
}

