make.ani2 <- function(sgm,pick="png",nf=1,width0=SGqk$width, height0=SGqk$height, xlim0=SGqk$xlim, ylim0=SGqk$ylim, cex=1, image.filter0=0.01, ...) 
	{
	require(geoTools)
	lex <- function(N) {
	ndig <- nchar(N)
	substr(formatC((1:N)/10^ndig,digits=ndig,format="f"),3,10000000)
	}
	times <- sgm$preds$t
	nt <- length(times)
	if (nf>1) { 
		nt <- length(times)*nf-nf+1
		ntf <- ((1:nt)+nf-1)/nf
		wgt <- (ntf-1)/(max(ntf)-1)
		if (verb) print(wgt)
		times <- (1-wgt)*times[1] + wgt*times[length(times)]
		if (verb) print(times)
	}
	labs <- lex(nt)
	tmp <- sgm
	if (pick=="png")  { 
	FUN <- png
	ext <- ".png" 
	}
	else {
	FUN <- jpeg
	ext <- ".jpeg"
	}
	cat("Plotting: ")
	for (i in 1:nt) {
		cat(i," ")
		if (nf==1)	tmp$preds$z <- sgm$preds$z[,,i]
		else if ((i-1)/nf == floor((i-1)/nf)) {
			if (verb) cat(((i-1)/nf)+1," ")
			tmp$preds$z <- sgm$preds$z[,,((i-1)/nf)+1]
			}			
		else { 
			ni <- floor(ntf[i])
			wgt <- ntf[i]-ni
			if (verb) cat(ni," ",wgt," ")
			tmp$preds$z <- (1-wgt)*sgm$preds$z[,,ni] + wgt*sgm$preds$z[,,ni+1] 
		}
	png(file=paste("./pngs/",i,ext,sep=""),width=width0,height=height0,
		bg="transparent")
	par(cex=cex)
	geoPlot.ani(manta,fit=tmp,pts.add=F,key=F,land.add=F,axes.add=F,
	xlim=xlim0,ylim=ylim0,scale.bar.add=F,mar.no.rot=rep(0,4),
	image.filter=image.filter0, ...)
	dev.off()
	}
	cat("\n")
}

