make.legend <- function(labs=c("L1","L2","L3"), head="Soft Corals", nh=length(head),
	 wadj=0.52, hadj=1, cols=rainbow(21), w=(max(nchar(head[1]))+2), 
	 name.png="legend.png", npt=72, leg.col="orange", leg.font = 2) {
#
# This code generates a png of 72*h*hadj X 0.8*72*w*wadj size in pixels
# h =  # logo lines and w = # logo characters across width
# npt controls image size 		
# 
	len <- length(labs)
	h <- (len+nh+1)*hadj
	if (is.function(cols)) cols <- cols(len)
	if (.Platform$GUI == "X11") png(name.png,width=npt*w*wadj,height=npt*h*hadj,
		bg = "transparent",type="cairo",antialias="none") 
	else png(name.png,width=npt*w*wadj,height=npt*h*hadj, bg = "transparent") 
	par(mar=rep(0,4))
	plot(c(0,w),c(0,h),type="n",xlab="",ylab="",axes=F)
	text(rep(0.5*w,nh),h:(h-nh+1),head,pos=1,cex=npt/14,col=leg.col,font=leg.font)
	text(rep(0.6*w,len),len:1,labs,cex=npt/15,col=leg.col,font=leg.font)
	points(rep(0.2*w,len),len:1,pch=22,lwd=2,col="black",bg=cols,cex=npt/5.2)
	dev.off()	
}


