make.legend.eric <- function(labs=c("L1","L2","L3"), wadj=0.52, hadj=1, cols=rainbow(21), 
	w=(max(nchar(head[1]))+2), name.png="legend.png", npt=72, leg.col="orange", leg.font=1) {
#
# This code generates a png of 72*h*hadj X 0.8*72*w*wadj size in pixels
# h =  # logo lines and w = # logo characters across width
# npt controls image size 		
# 
	len <- length(labs)
	h <- len*hadj
	if (is.function(cols)) cols <- cols(len)
	if (.Platform$GUI == "X11") png(name.png,width=npt*w*wadj,height=npt*h*hadj,
		bg = "transparent",type="cairo",antialias="gray") 
	else png(name.png,width=npt*w*wadj,height=npt*h*hadj, bg = "transparent",antialias="gray") 
	par(mar=rep(0,4))
	plot(c(0,w),c(0,h)+0.5,type="n",xlab="",ylab="",axes=F)
	text(rep(0.15*w,len),len:1,labs,cex=npt/15,col=leg.col,font=leg.font,adj=0)
	points(rep(0.05*w,len),len:1,pch=22,lwd=2,col="black",bg=cols,cex=npt/5.2)
	dev.off()	
}


