merge33 <- function(infiles = gname, about = TRUE, 
	fname = fname, logo=TRUE, sidebar=TRUE, sidebar.width=0.15) {
	n <- length(infiles)
	cat(n," files\n")
	nch <- nchar(infiles[1])
	outfile <- paste(substring(infiles[1],1,nch-8),"All.kml",sep="")
	lst <- list()
	lst[[1]] <- scan(infiles[1],what="character",sep="\n",quiet=TRUE)
	lst[[1]] <- gsub("<Point>",paste("<styleUrl>#msn_placemark_circle</styleUrl>","<Point>",sep="\n"),lst[[1]])

	for (i in 2:9) {
		tmp <- scan(infiles[i],what="character",sep="\n",quiet=TRUE)
		lst[[i]] <- tmp[3:(length(tmp)-1)]
	} 
	vph.labels <- c("Value","Precision","Hotspots","Precision","Hotspots")	

	if (about)  about.txt <- about.kml(fname)
	
# start KML 
	cat(lst[[1]][1:2],file=outfile,sep="\n")
	cat("<Folder>\n",file=outfile,append=TRUE)
	cat("<open>1</open>\n",file=outfile,append=TRUE)
	
# About here

	if (about) cat(about.txt,file=outfile,append=TRUE)

# End of About 

# start radio folder
	cat("<Folder>\n<name>Views of maps</name>\n<open>1</open>\n<Style>\n<ListStyle>\n<listItemType>radioFolder</listItemType>\n<bgColor>00ffffff</bgColor>\n</ListStyle>\n</Style>\n",file=outfile,append=TRUE)

# start normal view folder
	cat("<Folder>\n<name>Normal View</name>\n<open>1</open>\n<Style>\n<ListStyle>\n<listItemType>radioFolder</listItemType>\n<bgColor>00ffffff</bgColor>\n</ListStyle>\n</Style>\n",file=outfile,append=TRUE)
	cat("<LookAt>\n<longitude>148.1265</longitude>\n<latitude>-17.713</latitude>\n<altitude>0</altitude>\n<range>1775714.295282389</range>\n<tilt>-4.576908164204912e-14</tilt>\n	<heading>0.87218</heading>\n</LookAt>\n",file=outfile,append=TRUE)

	for (i in 2:4) {
		cat(paste("<Folder>\n<name>",vph.labels[i-1],"</name>\n"),file=outfile,append=TRUE)
		if (i==2) cat("<visibility>1</visibility>\n",file=outfile,append=TRUE)
		else cat("<visibility>0</visibility>\n",file=outfile,append=TRUE)
		write(lst[[i]],file=outfile,append=TRUE,sep="\n")
		write(lst[[i+5]],file=outfile,append=TRUE,sep="\n")
		cat("</Folder>\n",file=outfile,append=TRUE)
	}

	cat("</Folder>\n",file=outfile,append=TRUE)
# end normal view folder


# start expanded view folder
	cat("<Folder>\n<name>Expanded View</name>\n",file=outfile,append=TRUE)
	cat("<visibility>0</visibility>\n",file=outfile,append=TRUE)
	cat("<LookAt>\n<longitude>151.35545</longitude>\n<latitude>-14.8547</latitude>\n			<altitude>0</altitude>\n<range>2277126.362605218</range>\n<tilt>5.269785849425963e-15</tilt>\n	<heading>-40</heading>\n</LookAt>\n",file=outfile,append=TRUE)

	k <- 7
	for (i in c(2,5,6)) {
		cat(paste("<Folder>\n<name>",vph.labels[i-1],"</name>\n"),file=outfile,append=TRUE)
		cat("<visibility>0</visibility>\n",file=outfile,append=TRUE)
		write(lst[[i]],file=outfile,append=TRUE,sep="\n")
		write(lst[[k]],file=outfile,append=TRUE,sep="\n")
		cat("</Folder>\n",file=outfile,append=TRUE)
		k <- k+1
	}	

	cat("</Folder>\n",file=outfile,append=TRUE)
# end expanded view folder

	cat("</Folder>\n",file=outfile,append=TRUE)

# end of radio folder

# start extras folder

	cat('<Folder>\n<name>Extras</name>\n<open>1</open>\n',file=outfile,append=TRUE,sep="\n")
	
# blue background

# if (blue)
#	cat("\n<open>0</open>\n<GroundOverlay>\n<name>BlueBackground</name>\n
# <visibility>1</visibility>\n<drawOrder>0</drawOrder>\n<Icon>\n<href>Blue.png
#</href>\n<viewBoundScale>0.75</viewBoundScale>\n</Icon>\n<LatLonBox>\n<north>90</north>
#\n<south>-90</south>\n<east>180</east>\n<west>-180</west>\n</LatLonBox>\n</GroundOverlay>
#\n",file=outfile,append=TRUE,sep="\n")
# end blue

if (logo)
	cat('\n<open>1</open>\n<ScreenOverlay>\n<name>Logo</name>\n<drawOrder>3</drawOrder>\n<Icon>\n<href>logo.png</href>\n</Icon>\n<overlayXY x="0" y="0" xunits="fraction" yunits="fraction"/>\n<screenXY x="0.0" y="0.0" xunits="fraction" yunits="fraction"/>\n<rotationXY x="0.5" y="0.5" xunits="fraction" yunits="fraction"/>\n<size x="180" y="134" xunits="pixels" yunits="pixels"/>\n </ScreenOverlay>\n', file=outfile,append=TRUE,sep="\n")

if (sidebar)
	cat('\n<open>1</open>\n<ScreenOverlay>\n<name>Sidebar</name>\n<drawOrder>2</drawOrder>\n<Icon>\n<href>sidebar.png</href>\n</Icon>\n<overlayXY x="0" y="0" xunits="fraction" yunits="fraction"/>\n<screenXY x="0.0" y="0.0" xunits="fraction" yunits="fraction"/>\n<rotationXY x="0.5" y="0.5" xunits="fraction" yunits="fraction"/>\n<size x="',file=outfile,append=TRUE,sep="\n")
	write(sidebar.width,file=outfile,append=TRUE,sep="\n")
	cat('" y="1600" xunits="pixels" yunits="pixels"/>\n</ScreenOverlay>\n', file=outfile,append=TRUE,sep="\n")

	cat('</Folder>\n',file=outfile,append=TRUE,sep="\n")
	
# end extras folder

# start data folder
	cat("<Document>\n<name>Data</name>\n",file=outfile,append=TRUE)
#	cat("<Folder><name>Data</name>\n",file=outfile,append=TRUE)

# start style
cat('<Style id="sh_placemark_circle_highlight">\n<IconStyle>\n<color>7fffffff</color>\n<Icon>\n<href>http://maps.google.com/mapfiles/kml/shapes/placemark_circle_highlight.png</href>\n</Icon>\n</IconStyle>\n</Style>\n<Style id="sn_placemark_circle">\n<IconStyle>\n<color>7fffffff</color>\n<scale>0.8</scale>\n<Icon>\n<href>http://maps.google.com/mapfiles/kml/shapes/placemark_circle.png</href>\n</Icon>\n</IconStyle>\n</Style>\n<StyleMap id="msn_placemark_circle">\n<Pair>\n<key>normal</key>\n<styleUrl>#sn_placemark_circle</styleUrl>\n</Pair>\n<Pair>\n<key>highlight</key>\n<styleUrl>#sh_placemark_circle_highlight</styleUrl>\n</Pair>\n</StyleMap>\n',file=outfile,append=TRUE,sep="\n")
# end style
	cat("<Folder>\n",file=outfile,append=TRUE)
	cat(lst[[1]][(5:length(lst[[1]])-1)],file=outfile,append=TRUE,sep="\n") 
	cat("</Folder>\n",file=outfile,append=TRUE)
	cat("</Document>\n",file=outfile,append=TRUE)
# end data folder

	cat("</Folder>\n",file=outfile,append=TRUE)
	cat("</kml>\n",file=outfile,append=TRUE)
# end KML 
}
