mergeR <- function(outfile, infiles = gname, yvars = yvars, about = TRUE, 
	fname = fname, logo=TRUE, sidebar=TRUE, sidebar.width=200, effects=TRUE) {
	n <- length(infiles)
	lst <- list()
	for (i in 1:n) {
		tmp <- scan(infiles[i],what="character",sep="\n",quiet=TRUE)
		lst[[i]] <- tmp[3:(length(tmp)-1)]
	} 
	nvars <- n/2
	cat("nvars =",nvars,"\n")

	if (about)  about.txt <- about.kml(fname)

# start KML 
	cat('<?xml version="1.0" encoding="UTF-8"?>\n<kml xmlns="http://earth.google.com/kml/2.2">', file=outfile,sep="\n")
	cat("<Folder>\n",file=outfile,append=TRUE)
	cat("<open>1</open>\n",file=outfile,append=TRUE)
	
# About here

	if (about) cat(about.txt,file=outfile,append=TRUE)

# End of About 

# start radio folder
	cat("<Folder>\n<name>Views of maps</name>\n<open>1</open>\n<Style>\n<ListStyle>\n<listItemType>radioFolder</listItemType>\n<bgColor>00ffffff</bgColor>\n</ListStyle>\n</Style>\n",file=outfile,append=TRUE)

# start expanded view folder
	cat("<Folder>\n<name>Expanded View</name>\n",file=outfile,append=TRUE)
	cat("<visibility>0</visibility>\n",file=outfile,append=TRUE)
	cat("<LookAt>\n<longitude>151.35545</longitude>\n<latitude>-14.8547</latitude>\n			<altitude>0</altitude>\n<range>2277126.362605218</range>\n<tilt>5.269785849425963e-15</tilt>\n	<heading>-40</heading>\n</LookAt>\n",file=outfile,append=TRUE)

	for (i in 1:nvars) {
		cat(paste("<Folder>\n<name>",yvars[i],"</name>\n"),file=outfile,append=TRUE)
		cat("<visibility>0</visibility>\n",file=outfile,append=TRUE)
		write(lst[[i]],file=outfile,append=TRUE,sep="\n")
		write(lst[[i+nvars]],file=outfile,append=TRUE,sep="\n")
		cat("</Folder>\n",file=outfile,append=TRUE)
	}	

	cat("</Folder>\n",file=outfile,append=TRUE)
# end expanded view folder


	cat("</Folder>\n",file=outfile,append=TRUE)
# end of radio folder

# start extras folder

	cat('<Folder>\n<name>Extras</name>\n<open>1</open>\n',file=outfile,append=TRUE,sep="\n")

if (effects)
	cat('\n<open>1</open>\n<ScreenOverlay>\n<name>Effects</name>\n<drawOrder>3</drawOrder>\n<Icon>\n<href>effects.png</href>\n</Icon>\n<overlayXY x="0" y="0" xunits="fraction" yunits="fraction"/>\n<screenXY x="0.80" y="0.075" xunits="fraction" yunits="fraction"/>\n<rotationXY x="0.5" y="0.5" xunits="fraction" yunits="fraction"/>\n<size x="300" y="300" xunits="pixels" yunits="pixels"/>\n </ScreenOverlay>\n', file=outfile,append=TRUE,sep="\n")

if (logo)
	cat('\n<open>1</open>\n<ScreenOverlay>\n<name>Logo</name>\n<drawOrder>3</drawOrder>\n<Icon>\n<href>logo.png</href>\n</Icon>\n<overlayXY x="0" y="0" xunits="fraction" yunits="fraction"/>\n<screenXY x="0.0" y="0.00" xunits="fraction" yunits="fraction"/>\n<rotationXY x="0.5" y="0.5" xunits="fraction" yunits="fraction"/>\n<size x="180" y="134" xunits="pixels" yunits="pixels"/>\n </ScreenOverlay>\n', file=outfile,append=TRUE,sep="\n")

if (sidebar)
	cat('\n<open>1</open>\n<ScreenOverlay>\n<name>Sidebar</name>\n<drawOrder>2</drawOrder>\n<Icon>\n<href>sidebar.png</href>\n</Icon>\n<overlayXY x="0" y="0" xunits="fraction" yunits="fraction"/>\n<screenXY x="0.0" y="0.0" xunits="fraction" yunits="fraction"/>\n<rotationXY x="0.5" y="0.5" xunits="fraction" yunits="fraction"/>\n<size x="',file=outfile,append=TRUE,sep="\n")
	write(sidebar.width,file=outfile,append=TRUE,sep="\n")
	cat('" y="1600" xunits="pixels" yunits="pixels"/>\n</ScreenOverlay>\n', file=outfile,append=TRUE,sep="\n")


	cat('</Folder>\n',file=outfile,append=TRUE,sep="\n")
	
# end extras folder

	cat("</Folder>\n",file=outfile,append=TRUE)
	cat("</kml>\n",file=outfile,append=TRUE)
# end KML 
}
