`polygonholes` <-
function (coords, col = NA, border = NULL, xpd = NULL, density = NULL, 
    angle = 45, pbg = par("bg"), forcefill = TRUE, ...) 
{
    nParts <- attr(coords, "nParts")
    if (is.null(nParts)) 
        nParts <- 1
    pFrom <- attr(coords, "pstart")$from
    if (is.null(pFrom)) 
        pFrom <- 1
    pTo <- attr(coords, "pstart")$to
    if (is.null(pTo)) 
        pTo <- dim(coords)[1]
    if (is.na(col)) 
        hatch <- TRUE
    else hatch <- FALSE
    pO <- attr(coords, "plotOrder")
    if (is.null(pO)) 
        pO <- 1:nParts
    for (i in pO) {
        if (hatch) {
            if (forcefill || attr(coords, "ringDir")[i] == 1) {
                polygon(coords[pFrom[i]:pTo[i], ], border = border, 
                  xpd = xpd, density = density, angle = angle, ...)
            }
            else {
                polygon(coords[pFrom[i]:pTo[i], ], border = border, 
                  xpd = xpd, col = pbg, density = NULL, ...)
            }
        }
        else {
            if (forcefill || attr(coords, "ringDir")[i] == 1) {
                polygon(coords[pFrom[i]:pTo[i], ], border = border, 
                  xpd = xpd, col = ifelse(i == pO[1], col, "white"), ...)
            }
            else {
                polygon(coords[pFrom[i]:pTo[i], ], border = border, 
                  xpd = xpd, col = pbg, ...)
            }
        }
    }
}

