rotate.grid2 <- function(grid, alpha = 45, cent, eps) {
	require(akima)
	if (missing(cent)) cent <- round(c(mean(grid$x),mean(grid$y)),2)
	print(cent)
	if (missing(eps)) eps <- min(c(grid$x[2]-grid$x[1],grid$y[2]-grid$y[1]))
	print(eps)
	xlim <- c(min(grid$x),max(grid$x))
	ylim <- c(min(grid$y),max(grid$y))

	# convert grid to xyz matrix

	mat <- cbind(x=rep(grid$x,length(grid$y)),y=rep(grid$y,each=length(grid$x)))
	print(dim(mat))
	mat <- cbind(mat[!is.na(grid$z),],z=c(grid$z[!is.na(grid$z)]))
	print(summary(mat))
	print(dim(mat))
	plot(mat[,1],mat[,2],pch=".")
	
	# rotate the grid values

	mat[,1:2] <- scale(mat[,1:2], center = cent, scale = F)
	sth <- sin(pi * alpha/180)
	cth <- cos(pi * alpha/180)
	rotate <- matrix(c(cth, sth, -sth, cth), nrow = 2, byrow = F)
	mat[,1:2] <- mat[,1:2] %*% rotate

	plot(mat[,1],mat[,2],pch=".")
	print(summary(mat))
	print(dim(mat))

	# make new grid 

	xr <- range(mat[,1])
	xr1 <- floor(xr[1]/eps)*eps
	xr2 <- ceiling(xr[2]/eps)*eps
	xr <- c(xr1,xr2)	
	yr <- range(mat[,2])
	yr1 <- floor(yr[1]/eps)*eps
	yr2 <- ceiling(yr[2]/eps)*eps
	yr <- c(yr1,yr2)	

print(xr)
print(yr)
plot(xr,yr,pch=16,col=2,asp=1)
points(mat[,1],mat[,2],pch=",")
# text(mat[,1],mat[,2],mat[,3])
points(xr,yr,pch=16,col=2)

	newgrid <- interp(x=mat[,1], y=mat[,2], z=mat[,3], xo=seq(xr1,xr2,by=eps),
	 yo=seq(yr1,yr2,by=eps), extrap=FALSE)

#	image(newgrid, add=T)
#	newgrid$x <- newgrid$x + cent[1]
#	newgrid$y <- newgrid$y + cent[2]
	print(summary(newgrid$x))
	print(summary(newgrid$y))
	print(summary(c(newgrid$z)))
	newgrid
}
