rotate.grid3 <- function(grid, alpha=45, p=2, cent, eps) {
	require(akima)
	if (missing(cent)) cent <- round(c(mean(grid$x),mean(grid$y)),2)
	print(cent)
	if (missing(eps)) eps <- min(c(grid$x[2]-grid$x[1],grid$y[2]-grid$y[1]))
	print(eps)
	xlim <- c(min(grid$x),max(grid$x))
	ylim <- c(min(grid$y),max(grid$y))

	# convert grid to xyz matrix

	mat <- cbind(x=rep(grid$x,length(grid$y)),y=rep(grid$y,each=length(grid$x)))
	print(dim(mat))
	mat <- cbind(mat[!is.na(grid$z),],z=c(grid$z[!is.na(grid$z)]))
	print(summary(mat))
	print(dim(mat))
	image(mat)
	points(mat[,1],mat[,2],pch=1,asp=1)
	
	# rotate the grid values

	mat[,1:2] <- scale(mat[,1:2], center = cent, scale = F)
	sth <- sin(pi * alpha/180)
	cth <- cos(pi * alpha/180)
	rotate <- matrix(c(cth, sth, -sth, cth), nrow = 2, byrow = F)
	mat[,1:2] <- mat[,1:2] %*% rotate

#	plot(mat[,1],mat[,2],pch=2,asp=1)
	print(summary(mat))
	print(dim(mat))

	# make new grid 

	xr <- range(mat[,1])
	xr1 <- floor(xr[1]/eps)*eps
	xr2 <- ceiling(xr[2]/eps)*eps
	xr <- seq(xr1,xr2,by=eps)	
	yr <- range(mat[,2])
	yr1 <- floor(yr[1]/eps)*eps
	yr2 <- ceiling(yr[2]/eps)*eps
	yr <- seq(yr1,yr2,by=eps)	
	grid <- expand.grid(x=xr,y=yr)
	print(xr)
	print(yr)
	print(grid[1:15,])
	mmat <- paste(round(mat[,1],p)*10^p,round(mat[,2],p)*10^p,sep=" ")
	mgrid <- paste(round(grid[,1],p)*10^p,round(grid[,2],p)*10^p,sep=" ")
	print(mmat)
	print(mgrid)
	grid$z<-mat[,3][match(mgrid,mmat)]
	newgrid <- list(x=xr,y=yr,z=matrix(grid$z,ncol=length(xr)))
	print(summary(grid))
	image(mat)
	points(mat[,1],mat[,2],pch=1,asp=1)
}
