`surfer.gam.gi` <-
function (form, data, weights, grid.predict = TRUE, trim = TRUE, 
	xlim, ylim, xpnd = 0.01, alpha = 40, 
	cent, lat = "lat", long = "long", adj.mean = T, extrap = F, ptype = "response", 
    plt = FALSE, se = FALSE, se.trim = 0, xvals, aauto = TRUE, 
    aauto.vals = c(3:8, 10, 12, 15), grid = grid001.aa,
    aak.min = c("best","fit")[1], aak = 5, aafn = function(x) x, ...) 
{
    require(mgcv)
    require(acrossAlong)

	g2i <- function(x, preds, preds.se) {
		ndiv <- attr(x,"ndiv")
		xr <- range(x$long)
		xi <- seq(xr[1],xr[2],by=1/ndiv)
		nxi <- length(xi)
		yr <- range(x$lat)
		yi <- seq(yr[1],yr[2],by=1/ndiv)
		nyi <- length(yi)
		zmat <- matrix(NA,ncol=nyi,nrow=nxi)
		xins <- match(round(x$long*ndiv),round(xi*ndiv))
		yins <- match(round(x$lat*ndiv),round(yi*ndiv))
		zmat[cbind(xins,yins)] <- preds
		lst <- list(x=xi,y=yi,z=zmat)
		if (!missing(preds.se)) {
			zmat[cbind(xins,yins)] <- preds.se
			lst$z.se <- zmat
		}
		lst
	}
    aa <- acrossAlong(data[, c(long, lat)])
    data$across <- aa[, "across"]
    data$along <- aa[, "along"]
    if (aauto) {
        nl <- length(aauto.vals)
        res <- matrix(NA, nrow = nl, ncol = 2)
        res[, 1] <- aauto.vals
        dimnames(res) <- list(as.character(aauto.vals), c("aak","gcv"))
        for (i in 1:nl) {
            cat(i, " ")
            temp <- data
            temp$along <- aauto.vals[i] * aafn(aa[, "along"])
            if (missing(weights)) 
                fit <- gam(formula = form, data = temp, ...)
            else fit <- gam(formula = form, data = temp, weights = weights, 
                ...)
            res[i, 2] <- fit$gcv.ubre
        }
        minr <- (1:nl)[res[, 2] == min(res[, 2])][1]
        if (aak.min == "best") 
            aak <- res[minr, 1]
        else if (minr == 1 | minr == nl) 
            aak <- res[minr, 1]
        else {
            res3 <- data.frame(res[(minr - 1):(minr + 1), ])
            fit <- lm(gcv ~ poly(aak, 2), res3)
            newdf <- data.frame(aak = seq(min(res3$aak), max(res3$aak), 
                length = 100))
            min.aak <- min(aak.pred <- predict(fit, new = newdf, 
                type = ptype))
            aak <- newdf[aak.pred == min.aak, ]
        }
        cat("\n")
        print(res)
        cat("Best aak =", aak, "\n")
    }
    data$along <- aak * aafn(aa[, "along"])
    if (missing(weights)) 
        fit <- gam(formula = form, data = data, ...)
    else fit <- gam(formula = form, data = data, weights = weights,  ...)
    print(summary(fit))

    if (grid.predict) {
        if (missing(xlim) & missing(ylim)) {
            xlim <- range(data[, long])
            ylim <- range(data[, lat])
        }
        if (xpnd > 0) {
            xlim <- xlim + xpnd * c(-1, 1) * diff(xlim)
            ylim <- ylim + xpnd * c(-1, 1) * diff(ylim)
        }
        grid <- grid[grid$long>xlim[1] & grid$long<xlim[2] & grid$lat>ylim[1] & grid$lat<ylim[2],]
        grid$along <- aak * aafn(grid$along)
        nxxs <- length(tlabs <- attributes(fit$terms)$term.labels) - 2

        if (!se) {
            pd <- predict(fit, newdata = grid, type = ptype)
            preds <- g2i(grid, pd)
        }
        else {
            if (!se.trim) {
		        pd <- predict(fit, newdata = grid, type = ptype, se = T)
		        preds <- g2i(grid, pd$fit, pd$se.fit)
            }
            else {
                pd <- predict(fit, newdata = grid, type = "link", se = T)
		        preds <- g2i(grid, pd$fit, pd$se.fit)
                preds.fit <- predict(fit, se = T, type = "link")
			    bxp <- boxplot(preds.fit$se.fit,range=se.trim,plot=F)
				se.high <- (bxp$stats[4] + (bxp$stats[4] - bxp$stats[2]) * se.trim) 
			    omit.high <- preds$z.se > se.high
			    if (any(omit.high)) {
					cat("Omitting",round(100 * sum(omit.high,na.rm=T)/
					sum(!is.na(preds$z.se)),2), "% pixels on high SEs\n")
					preds$z[omit.high] <- NA
					preds$z.se[omit.high] <- NA
					preds$preds.fit <- preds.fit
			    }
            	if (fit$family$family != "identity") {
		        	preds$z <- fit$family$linkinv(preds$z)
					preds$z.se <- fit$family$linkinv(preds$z.se)
            	}
            }
        }
        fit$preds <- preds
    }
    attr(fit, "aak") <- aak
    class(fit) <- c("surfer", class(fit))
    fit
}

