`geoPlot4k` <-
function (data, preds, xlim, ylim, auto.cex = TRUE, lat = "lat", long = "long",
    image.add = TRUE, image.se = FALSE, image.col = colorRampPalette(c("lightgoldenrodyellow", 
    "yellow", "orange", "red", "darkred"), space = "Lab"), image.ncol = 1000, image.quant,
     image.breaks = NULL, image.filter, se = FALSE, ...) 
{
    ret <- plot(range(preds$x), range(preds$y), xlab = "", 
    ylab = "", type = "n", axes = F, xlim = xlim, ylim = ylim,
    xaxs = "i", yaxs = "i",  ...)
    if (se) {
        if (is.null(preds$z.se)) 
            stop("No SEs available\n")
        else preds$z <- preds$z.se
    }
    if (!missing(image.filter)) 
    	preds$z[preds$z <= image.filter] <- NA
    if (class(image.col) == "function") 
          image.c <- image.col(image.ncol)
    else image.c <- image.col

    if (image.add) {
        if (missing(image.quant) & is.null(image.breaks))
          image(preds, col = image.c, axes = F, add = T)
        else {
          if (is.null(image.breaks)) breaks <- quantile(preds$z,
           probs = image.quant, na.rm = T)
		  else breaks <- image.breaks
          cat("Breaks: ", signif(breaks, 2), "\n")
          image(preds, col = image.c, axes = F, add = T, breaks = breaks)
        }
    }
}

