makegrid.density.merge <- function(x,y,eps=0.5,use.line=1,size=0.001) {

##
## function for generating grids with multiple areas based on spatial densities of points
## borders of grids are defined by a common (low) density boundary selected by the user
##
## "x,y": long and lat respectively
## "eps": controls the scale of smoothing -- try different values (range 0.1,1 ??) !!
## "use.lines": lines of the density smooth are labelled 1,2,... 
##    select which you want as your boundary
## "size": cell size of the grid; typically 0.01 for intial model selection, 
##    and 0.001 - 0.0005 for gridded outpus (ASCII & KMLs)
## 

	lst <- list()
	for (i in length(use.line)) lst[[i]] <- makegrid.density(x,y,eps=eps,use.line=i,size=size) 
	grid <- do.call("rbind",lst)
	attrb(grid,"ndiv") <- round(1/size)
	grid
}
