## 
## Code to import ESRI masks an then apply mask to clip existing grids
##
require(spsurvey)
require(maptools)

reefclip <- read.shape("AIMS-domain_masks-reefs.shp")
plot.Map(reefclip)
class(reefclip)
reefclip.poly <- Map2poly(reefclip)
grp <- rep(0,188138/2)
grp2 <- cumsum(grp)
reefclip.lst <- split(as.data.frame(reefclip.poly[[1]]),grp2)
for (i in 1:length(reefclip.lst)) reefclip.lst[[i]] <- na.omit(reefclip.lst[[i]])

library(gridaa)

#########

nr <- nrow(grid010.aa)
nc <- length(reefclip.lst)
n <- 1000
nall <- ceiling(nr/n)
counts010 <- rep(0,nr)

for (i in 1:nall) {
index <- c(((i-1)*n+1):min(n*i,nr))
cat(i," ",range(index),"\n")
for (j in 1:nc)
counts010[index] <- counts010[index] + 1*poly.in(as.matrix(grid010.aa[index,1:2]),as.matrix(reefclip.lst[[j]]))
}
summary(counts010)

#########

nr <- nrow(grid005.aa)
nc <- length(reefclip.lst)
n <- 1000
nall <- ceiling(nr/n)
counts005 <- rep(0,nr)

for (i in 1:nall) {
index <- c(((i-1)*n+1):min(n*i,nr))
cat(i," ",range(index),"\n")
for (j in 1:nc)
counts005[index] <- counts005[index] + 1*poly.in(as.matrix(grid005.aa[index,1:2]),as.matrix(reefclip.lst[[j]]))
}
summary(counts005)

#########

nr <- nrow(grid002.aa)
nc <- length(reefclip.lst)
n <- 1000
nall <- ceiling(nr/n)
counts002 <- rep(0,nr)

for (i in 1:nall) {
index <- c(((i-1)*n+1):min(n*i,nr))
cat(i," ",range(index),"\n")
for (j in 1:nc)
counts002[index] <- counts002[index] + 1*poly.in(as.matrix(grid002.aa[index,1:2]),as.matrix(reefclip.lst[[j]]))
}
summary(counts002)

nr <- nrow(grid001.aa)
nc <- length(reefclip.lst)
n <- 1000
nall <- ceiling(nr/n)
counts001 <- rep(0,nr)

for (i in 1:nall) {
index <- c(((i-1)*n+1):min(n*i,nr))
cat(i," ",range(index),"\n")
for (j in 1:nc)
counts001[index] <- counts001[index] + 1*poly.in(as.matrix(grid001.aa[index,1:2]),as.matrix(reefclip.lst[[j]]))
}
summary(counts001)










